<template>
  <div class="feed-summary-container">
    <div class="feed-summary-inner">
      <div class="left-side-menu">
        <project-side-menu ref="projectSideMenu" :menuTree="menuTreeList" :menuOptions="menuOptions" :unique-opened="false"
          :default-active="currentNodeName" @select="menuSelect">
          <template slot="房建类成本科目-1">
            <img src="@/assets/images/projectCostLedger/icon_cost_detail_2.svg" alt="">
            <div class="project-sub-menu-title-text">房建类成本科目</div>
          </template>
          <template slot="未归类项目-1">
            <img src="@/assets/images/projectCostLedger/icon_cost_detail_3.svg" alt="">
            <div class="project-sub-menu-title-text">未归类项目</div>
          </template>
        </project-side-menu>
      </div>
      <div class="right-table-list-container">
        <div class="project-table-list-header">
          <div class="project-table-list-haeder-left">
            <el-select v-model="recordDate" placeholder="请选择年月" class="project-month-select-options" clearable @change="monthChange">
              <el-option v-for="item in monthList" :key="item.value" :label="item.label" :value="item.value">
              </el-option>
            </el-select>
          </div>
          <div class="project-table-list-haeder-right">
            <!-- 实体工程材料单位换算 -->
            <el-button type="primary" size="medium" class="unit-conversion-btn" v-if="currentParentName.indexOf('实体工程材料') != -1">单位换算</el-button>
            <!-- 填写实际成本 -->
            <el-button type="primary" size="medium" class="actual-cost-btn" v-else
              @click="addActualCostEditStatus ? saveActualCost() : fillActualCost()">{{addActualCostEditStatus ? '保存成本' : '填写实际成本'}}</el-button>
            <!-- 表头设置组件 -->
            <dsk-table-header-setting :settingList="formColum" @settingChange="settingChange"></dsk-table-header-setting>
          </div>
        </div>
        <!-- 数据列表部分 -->
        <div class="project-feedsummary-list-container">
          <dsk-skeleton v-if="tableLoading"></dsk-skeleton>
          <custom-table :tableData="tableDataList" :formColum="formColum" v-else-if="!tableLoading" :max-height="true" :tableDataTotal="total"
            :paging="false">
            <template slot="action-field-bar" slot-scope="scope">
              <div class="project-action-field-bar" v-if="scope.row.id != '0'">
                <span class="push-project">推送工程量</span>
              </div>
              <span v-else>-</span>
            </template>
          </custom-table>
        </div>
      </div>
    </div>

    <!-- 填写实际成本触发 -->
    <add-actual-cost v-model="showAddActualCost" :project-create-time="projectDetailInfo.createTime" @timeSelect="timeSelect"></add-actual-cost>

  </div>
</template>
<script>
import ProjectSideMenu from "@/views/projectCostLedger/detail/components/ProjectSideMenu";
import { getFeedSummaryMenuTreeApi, getFeedSummaryMonthListApi, getFeedSummaryListApi,getFeedSummaryConversionNotice } from "@/api/projectCostLedger";
import DskTableHeaderSetting from "@/components/DskTableHeaderSetting";
import DskSkeleton from "@/components/DskSkeleton";
import CustomTable from "@/components/CustomTable";
import AddActualCost from "./components/AddActualCost";
import { v4 } from 'uuid';
import dayjs from "dayjs";
import { cloneDeep } from "lodash-es";
import { add } from "@/utils/decimal";

// 需要统计的字段名
const statisticsPropNames = [
  "guidePrice",
  "bidUnitPrice",
  "unitPriceDifference",
  "quantity",
  "combinedPrice",
  "combinedPriceTax",
  "quantities",
  "totalQuantities",
  "purchaseUnitPrice"
];

export default {
  name: "feedSummary",
  props: {
    // 项目ID
    projectId: {
      type: String,
      required: true,
      default: ""
    },
    // 详情信息
    projectDetailInfo: {
      type: Object,
      default: () => ({})
    }
  },
  watch: {
    projectDetailInfo: {
      handler(newValue) {
        this.comProjectDetailInfo = newValue ? cloneDeep(newValue) : {};
        this.init(this.comProjectDetailInfo);
      },
      deep: true,
    },
    projectId: {
      handler(newValue) {
        this.comProjectId = newValue;
      }
    }
  },
  components: {
    ProjectSideMenu,
    DskTableHeaderSetting,
    CustomTable,
    DskSkeleton,
    AddActualCost
  },
  data() {
    return {
      menuOptions: {
        nodeName: "name",
        nodeValue: "name",
      },
      comProjectDetailInfo: this.projectDetailInfo ? cloneDeep(this.projectDetailInfo) : {},
      comProjectId: this.projectId,
      menuTreeList: [],
      // 加载数据列表
      tableLoading: true,
      total: 0,
      // 列表表头
      formColum: [
        { label: '序号', prop: "staticSerialNumber", type: "index", lock: true, width: "53", fixed: "left", uid: v4() },
        { label: '成本科目', prop: "cbSubjectName", width: "137", uid: v4(), slot: true },
        { label: '公司编码', prop: "companyNo", width: "137", uid: v4() },
        { label: '集团编码', prop: "orgNo", width: "137", uid: v4() },
        { label: '名称', prop: "cbName", width: "232", uid: v4() },
        { label: '工作内容', prop: "jobContent", width: "341", uid: v4() },
        { label: '计算规则', prop: "calculationRule", width: "137", uid: v4() },
        { label: '单位', prop: "unit", width: "57", uid: v4() },
        { label: '甲供材料说明', prop: "materialDescription", width: "137", uid: v4() },
        {
          label: '计划成本', prop: "jhcb", align: "center", uid: v4(), children: [
            { label: '指导价格', prop: "guidePrice", minWidth: "81", uid: v4() },
            { label: '投标选用单价（不含税）', prop: "bidUnitPrice", minWidth: "179", uid: v4() },
            { label: '单价差额', prop: "unitPriceDifference", minWidth: "81", uid: v4() },
            { label: '数量', prop: "quantity", minWidth: "53", uid: v4() },
            { label: '合价（不含税）', prop: "combinedPrice", minWidth: "123", uid: v4() },
            { label: '合价（含税）', prop: "combinedPriceTax", minWidth: "109", uid: v4() },
            { label: '品牌名称', prop: "brandName", minWidth: "81", uid: v4() },
            { label: '投标选用来源', prop: "bidSource", minWidth: "109", uid: v4() },
          ]
        },
        {
          label: '实际成本', prop: "sjcb", align: "center", uid: v4(), children: [
            { label: '本月工程量', prop: "quantities", minWidth: "95", uid: v4() },
            { label: '截止本月工程量', prop: "totalQuantities", minWidth: "123", uid: v4() },
            { label: '本月采购单价', prop: "purchaseUnitPrice", minWidth: "109", uid: v4() },
            { label: '填写时间', prop: "createTime", minWidth: "109", uid: v4() },
          ]
        },
        { label: '推送工程量', prop: "pushQuantities", width: "95", uid: v4() },
        { label: '备注', prop: "remark", width: "115", uid: v4(), slot: true },
        { label: '操作', prop: "action-field-bar", width: "99", uid: v4(), fixed: "right" },
      ],
      // 已记录月份集合
      monthList: [],
      // 源数据月份
      originMonthList: [],
      // 当前查询的数据月份
      recordDate: "",
      // 历史查询月份
      oldRecordDate: "",
      // 当前选中子菜单的父类名称
      currentParentName: "",
      // 当前选中的成本科目
      currentNodeName: "",
      // 数据列表
      tableDataList: [],
      statisticsParentName: ["劳务分包工程", "专业分包工程"],
      // 填写实际成本弹窗
      showAddActualCost: false,
      // 填写实际成本 编辑状态
      addActualCostEditStatus: false,
      // 当前选择的成本年份
      selectActualCostTime: ""
    };
  },
  //可访问data属性
  created() {
    this.init(this.comProjectDetailInfo);
  },
  //计算集
  computed: {
    hasTarget() {
      return this.statisticsParentName.includes(this.currentParentName);
    }
  },
  //方法集
  methods: {
    async init(detail = {}) {
      try {
        const { projectId, cbStage } = detail;
        if (!projectId) return;
        const params = {
          projectId,
          cbStage
        };
        await this.getFeedSummaryMenuTree(params);
        await this.getFeedSummaryMonthList(params);
        await this.initDefaultSetting();
      } catch (error) {
        console.log(error);
      } finally {
        this.tableLoading = false;
      }
    },
    async initDefaultSetting() {
      try {
        await this.$nextTick();
        const menus = this.$refs["projectSideMenu"].getResultMenuList();
        const defaultCurrent = this.findMenuNode(menus, "结构劳务分包");
        // 默认选中结构劳务分包
        if (defaultCurrent) {
          this.currentNodeName = defaultCurrent.nodeName;
          const parentName = defaultCurrent.parent ? this.getCurrentType(defaultCurrent.parent) : defaultCurrent.name;
          if (parentName) this.currentParentName = parentName;
          const params = this.createRequestConditions();
          await this.getFeedSummaryList(params);
        }
      } catch (error) {
        console.log(error);
      }
    },
    getNowMonth() {
      return dayjs(new Date().valueOf()).format("YYYYMM");
    },
    createRequestConditions() {
      const { projectId, cbStage } = this.comProjectDetailInfo;
      const params = {
        projectId,
        cbStage
      };
      params["cbSubjectName"] = this.currentNodeName;
      // 判断当月是否存在于server返回month集合中
      const _now = this.getNowMonth();
      if (this.includeNowMonth(_now)) {
        params["recordDate"] = _now;
      }
      return params;
    },
    // 返回当前月是否在server month集合中
    includeNowMonth(time) {
      return this.originMonthList.includes(time);
    },
    findMenuNode(tree, nodeName, targetName = "nodeName") {
      for (const item of tree) {
        if (item[targetName] == nodeName) return item;
        if (item.children instanceof Array) {
          const result = this.findMenuNode(item.children, nodeName, targetName);
          if (result) return result;
        }
      }
    },
    async getFeedSummaryList(params = {}) {
      try {
        this.tableLoading = true;
        const list = await getFeedSummaryListApi(params);
        if (list.code == 200 && list.data instanceof Array) {
          const _temp = list.data;
          // 计算总和
          if (this.hasTarget && _temp.length) {
            const row = this.countRowParams(_temp, statisticsPropNames);
            _temp.unshift(row);
          }
          this.tableDataList = _temp;
          this.total = _temp.length;
        }
      } catch (error) {
        console.log(error);
      } finally {
        this.tableLoading = false;
      }
    },
    countRowParams(arraylist = [], _statisticsPropNames) {
      if (arraylist.length) {
        const _template = {};
        const _temp = cloneDeep(arraylist[0]);
        const keys = Object.keys(_temp);
        // 映射key
        for (const key of keys) {
          if (key == "id") {
            _template[key] = "0";
            continue;
          } else if (key == "cbSubjectName") {
            _template[key] = "合计";
            continue;
          }
          _template[key] = "";
        }
        // 循环统计 需要统计的列 总数
        for (const prop of _statisticsPropNames) {
          const sum = arraylist.reduce((pre, current, index) => {
            const before = Object.prototype.toString.call(pre) == "[object Object]" ? pre[prop] ? pre[prop] : 0 : parseFloat(pre) ? pre : 0;
            const after = Object.prototype.toString.call(current) == "[object Object]" ? current[prop] ? current[prop] : 0 : parseFloat(current) ? current : 0;
            return add(before, after);
          }, 0);
          // 对应key 赋值结果
          _template[prop] = sum;
        }

        return _template;
      }
    },
    async getFeedSummaryMenuTree(params) {
      try {
        const result = await getFeedSummaryMenuTreeApi(params);
        if (result.code == 200 && result.data instanceof Array) {
          const _tempArray = result.data;
          this.menuTreeList = _tempArray;
        }
      } catch (error) {

      }
    },
    async getFeedSummaryMonthList(params) {
      try {
        const monthList = await getFeedSummaryMonthListApi(params);
        if (monthList.code == 200 && monthList.data instanceof Array) {
          const data = monthList.data;
          this.originMonthList = cloneDeep(data);
          const _now = this.getNowMonth();
          this.recordDate = _now;
          this.oldRecordDate = _now;
          // 默认以当前月数据为准 若不包含当前月 需要手动push数据
          if (!data.includes(_now)) {
            data.push(_now);
          }
          // 年月排序
          let _tempMonthList = this.monthsSort(data);
          _tempMonthList = _tempMonthList.map(item => {
            return {
              label: dayjs(item).format("YYYY年MM月"),
              value: item
            };
          });
          this.monthList = _tempMonthList;
        }
      } catch (error) {

      }
    },
    monthsSort(monthList) {
      const sortResult = monthList.sort((before, after) => {
        const _before = Object.prototype.toString.call(before) == "[object Object]" ? before["value"] : before;
        const _after = Object.prototype.toString.call(before) == "[object Object]" ? after["value"] : after;
        return parseInt(_after) - parseInt(_before);
      });
      return sortResult;
    },
    monthChange(month) {
      // 当前月
      const _now = this.getNowMonth();
      // 请求列表参数
      const params = this.createRequestConditions();
      // 清空了年月默认选中当前月
      if (!month) {
        this.recordDate = _now;
        // 如果命中的旧月份 等于当前月 且 不处于编辑状态 说明清空的是当前月 不调用接口
        if (this.oldRecordDate == _now && !this.addActualCostEditStatus) return;
      } else {
        // 正常选择
        params["recordDate"] = month;
        // 记录历史切换年月
        this.oldRecordDate = month;
      }
      this.resetEditStatus();
      // 获取列表数据
      this.getFeedSummaryList(params);
    },
    menuSelect(currentId, currentTemp) {
      this.resetEditStatus();
      this.currentNodeName = currentId;
      const parentName = currentTemp.parent ? this.getCurrentType(currentTemp.parent) : currentId;
      if (parentName) this.currentParentName = parentName;
      // 请求数据列表
      const params = this.createRequestConditions();
      this.getFeedSummaryList(params);
      if(this.currentParentName.indexOf('实体工程材料') != -1){
        const {  projectId,cbStage } = this.comProjectDetailInfo;
        const params = {
          projectId,
          cbStage
        };
        params["cbSubjectName"] = this.currentNodeName;
        // 判断当月是否存在于server返回month集合中
        const _now = this.getNowMonth();
        if (this.includeNowMonth(_now)) {
          params["recordDate"] = _now;
        }
        this.getFeedSummaryConversionNotice(params)
      }
    },
    async getFeedSummaryConversionNotice(params) {
      const data = await getFeedSummaryConversionNotice(params);
      if (data.data == 500) {
        this.$confirm('系统检测到您近一月未进行物料单位换算，是否立即进行换算？', '温馨提示', {
          confirmButtonText: '立即换算',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {

        }).catch(() => {
          this.$message({
            type: 'info',
            message: '已取消删除'
          });
        });
      }
    },
    getCurrentType(parent) {
      if (parent.level == 2) {
        return parent.nodeName;
      }
      if (parent.parent) {
        return this.getCurrentType(parent.parent);
      }
    },
    // 表头设置变化
    async settingChange(use) {
      try {
        this.formColum = use;
      } catch (error) {

      }
    },
    // 填写或修改新的 成本月份
    fillActualCost() {
      this.showAddActualCost = true;
    },
    // 保存
    saveActualCost() {

    },
    // 编辑状态下 进行了其它操作
    resetEditStatus() {
      // 当前需要编辑或者新增的成本年份
      const _selectActualCostTime = this.selectActualCostTime;
      this.addActualCostEditStatus = false;
      this.selectActualCostTime = "";
      /**
       * 判断 当前需要编辑 或者新增的成本年份是否存在于server返回的month数组中
       * 默认本月
      */
      if (!this.originMonthList.includes(_selectActualCostTime) && _selectActualCostTime != this.getNowMonth()) {
        const index = this.monthList.findIndex(item => item.value == _selectActualCostTime);
        if (index != -1) {
          this.monthList.splice(index, 1);
        }
      }
    },
    async timeSelect(selectTime) {
      // 编辑状态
      this.addActualCostEditStatus = true;
      this.selectActualCostTime = selectTime;
      // 判断是否包含 选择的年月 包含则修改 未包含则新增
      const findReslut = this.originMonthList.includes(selectTime) || this.monthList.find(item => item.value == selectTime);
      const params = this.createRequestConditions();
      if (!findReslut) {
        // 不包含当前所选月 新增数据
        let _temp = JSON.parse(JSON.stringify(this.monthList));
        _temp.push({
          label: dayjs(selectTime).format("YYYY年MM月"),
          value: selectTime
        });
        _temp = this.monthsSort(_temp);
        console.log(_temp);
        this.monthList = _temp;
      }
      this.recordDate = selectTime;
      this.oldRecordDate = selectTime;
      params["recordDate"] = selectTime;
      // 获取选中月数据
      await this.getFeedSummaryList(params);
    }
  },
}
</script>
<style lang="scss" scoped>
.feed-summary-container {
  width: 100%;
  height: 100%;

  .feed-summary-inner {
    width: 100%;
    height: 100%;
    display: flex;
    align-items: center;

    .left-side-menu {
      width: 220px;
      min-width: 220px;
      height: 100%;
    }
    .right-table-list-container {
      width: calc(100% - 220px);
      height: 100%;
      box-sizing: border-box;
      background: #fff;
      padding: 16px;

      ::v-deep .project-table-list-header {
        margin-bottom: 16px;
        display: flex;
        align-items: center;
        justify-content: space-between;

        .project-table-list-haeder-left {
          display: flex;
          align-items: center;
          .project-month-select-options {
            width: 140px;
            .el-input__inner {
              height: 32px;
              line-height: 32px;
              padding: 0px 12px;
              border-radius: 2px;
              border-color: #dcdfe6;
              font-size: 14px;
              color: #232323;
              font-weight: 350;
            }
            .el-input__suffix {
              right: 12px;
              .el-input__icon {
                line-height: 32px;
                width: auto;
              }
            }
            .el-input__prefix {
              display: none;
            }
          }
        }

        .project-table-list-haeder-right {
          display: flex;
          align-items: center;

          .actual-cost-btn,
          .unit-conversion-btn {
            height: 32px;
            display: flex;
            align-items: center;
            justify-content: center;
            padding: 0px 12px;
            background-color: #0081ff;
            border-color: #0081ff;
            border-radius: 4px;
            color: #fff;
            font-size: 14px;
            font-weight: 350;
            margin-right: 16px;
          }
        }
      }

      .project-feedsummary-list-container {
        width: 100%;
        height: calc(100% - 48px);
        overflow: auto;

        .dsk-skeleton-outer-container {
          padding: 0px;
          height: 100%;
        }

        ::v-deep .table-list-com-ins {
          height: 100%;
          .table-item {
            .el-table {
              th {
                height: 40px;
              }
              .cell {
                font-size: 14px;
                font-weight: 350;
              }
            }
          }
        }

        .project-action-field-bar {
          display: flex;
          align-items: center;

          .push-project {
            color: #0081ff;
            font-size: 14px;
            font-weight: 350;
            cursor: pointer;
          }
        }
      }
    }
  }
}
</style>
